package com.cicdi.notify;

import com.cicdi.notify.template.Template;

/**
 * 通知器管理
 *
 * @author xueye
 */
public interface NotifierManager {

    /**
     * @param type 通知类型 {@link NotifyType}
     * @param id   唯一标识
     * @param <T>  模板类型
     * @return 通知器
     */
    <T extends Template> Notifier<T> getNotifier(NotifyType type, String id);

    /**
     * 重新加载通知管理器
     *
     * @param id 通知管理器ID
     */
    void reload(String id);

    void registerProvider(NotifierProvider provider);
}
