package com.cicdi.notify.dingtalk;

import com.alibaba.fastjson.JSONObject;
import com.cicdi.notify.template.Template;

import java.util.Collections;
import java.util.Map;

/**
 * 钉钉消息通知模板
 *
 * @author xueye
 */
public class DingTalkMessageTemplate implements Template {

    /**
     * 应用ID
     */
    private String agentId;

    private String userIdList;

    private String departmentIdList;

    private boolean toAllUser;

    private String message;

    public String getAgentId() {
        return agentId;
    }

    public void setAgentId(String agentId) {
        this.agentId = agentId;
    }

    public String getUserIdList() {
        return userIdList;
    }

    public void setUserIdList(String userIdList) {
        this.userIdList = userIdList;
    }

    public String getDepartmentIdList() {
        return departmentIdList;
    }

    public void setDepartmentIdList(String departmentIdList) {
        this.departmentIdList = departmentIdList;
    }

    public boolean isToAllUser() {
        return toAllUser;
    }

    public void setToAllUser(boolean toAllUser) {
        this.toAllUser = toAllUser;
    }

    public String getMessage() {
        return message;
    }

    public void setMessage(String message) {
        this.message = message;
    }

    public String createFormInserter(Map<String, Object> context) {
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("agent_id", this.getAgentId());
        jsonObject.put("to_all_user", this.toAllUser);
        jsonObject.put("msg", createMessage(context));

        if (null != userIdList && !"".equals(userIdList)) {
            jsonObject.put("userid_list", createUserIdList(context));
        }
        if (null != departmentIdList && !"".equals(departmentIdList)) {
            jsonObject.put("dept_id_list", createDepartmentIdList(context));
        }
        return jsonObject.toJSONString();
    }

//    public UriComponentsBuilder createUriParameter(UriComponentsBuilder builder, Map<String, Object> context) {
//        builder.queryParam("agent_id", this.getAgentId())
//                .queryParam("to_all_user", String.valueOf(toAllUser))
//                .queryParam("msg", this.createMessage(context));
//        if (StringUtils.hasText(userIdList)) {
//            builder.queryParam("userid_list", this.createUserIdList(context));
//        }
//        if (StringUtils.hasText(departmentIdList)) {
//            builder.queryParam("dept_id_list", this.createDepartmentIdList(context));
//        }
//        return builder;
//    }

    public String createUserIdList(Map<String, Object> context) {
        if (null == userIdList || "".equals(userIdList)) {
            return userIdList;
        }
//        return ExpressionUtils.analytical(userIdList, context, "spel");
        return userIdList;
    }

    public String createDepartmentIdList(Map<String, Object> context) {
        if (null == departmentIdList || "".equals(departmentIdList)) {
            return departmentIdList;
        }
        return departmentIdList;
//        return ExpressionUtils.analytical(departmentIdList, context, "spel");
    }

    public JSONObject createMessage(Map<String, Object> context) {
        JSONObject json = new JSONObject();
        json.put("msgtype", "text");
        json.put("text", Collections.singletonMap("content", message));
//        json.put("text", Collections.singletonMap("content", ExpressionUtils.analytical(message, context.getAllValues(), "spel")));
        String s = json.toJSONString();
//        return json.toJSONString();
        return json;
    }

}
