package com.cicdi.notify.wechat;

import com.alibaba.fastjson.JSON;
import com.cicdi.notify.*;
import com.cicdi.notify.template.TemplateManager;
import com.cicdi.notify.template.TemplateProperties;
import com.cicdi.notify.template.TemplateProvider;

import java.util.Map;

public class WechatNotifierProvider implements NotifierProvider, TemplateProvider {

    private final TemplateManager templateManager;

    public WechatNotifierProvider(TemplateManager templateManager) {
        this.templateManager = templateManager;
    }

//    public static final DefaultConfigMetadata notifierConfig = new DefaultConfigMetadata("通知配置", "")
//            .add("corpId", "corpId", "", new StringType().expand(ConfigMetadataConstants.required.value(true)))
//            .add("corpSecret", "corpSecret", "", new StringType());
//
//    public static final DefaultConfigMetadata templateConfig = new DefaultConfigMetadata("模版配置", "")
//            .add("agentId", "应用ID", "", new StringType().expand(ConfigMetadataConstants.required.value(true)))
//            .add("toUser", "收信人ID", "与部门ID不能同时为空", new StringType())
//            .add("toParty", "收信部门ID", "与收信人ID不能同时为空", new StringType())
//            .add("toTag", "按标签推送", "", new StringType())
//            .add("message", "内容", "最大不超过500字", new StringType().expand(ConfigMetadataConstants.maxLength.value(500L)));

    @Override
    public NotifyType getType() {
        return DefaultNotifyType.wechat;
    }

    @Override
    public Provider getProvider() {
        return WechatProvider.corpMessage;
    }

    @Override
    public WechatMessageTemplate createTemplate(TemplateProperties properties) {
        return JSON.parseObject(properties.getTemplate(), WechatMessageTemplate.class);
//        return Mono.fromSupplier(() -> ValidatorUtils.tryValidate(JSON.parseObject(properties.getTemplate(), org.jetlinks.community.notify.wechat.WechatMessageTemplate.class)));
    }

    @Override
    public WeixinCorpNotifier createNotifier(NotifierProperties properties) {
//      WechatCorpProperties wechatCorpProperties = FastBeanCopier.copy(properties.getConfiguration(), new WechatCorpProperties());
        Map<String, Object> config = properties.getConfiguration();
        WechatCorpProperties wechatCorpProperties = new WechatCorpProperties();
        wechatCorpProperties.setCorpId((String) config.get("corpId"));
        wechatCorpProperties.setCorpSecret((String) config.get("corpSecret"));
        return new WeixinCorpNotifier(properties.getId(), wechatCorpProperties, templateManager);
//            return Mono.just(new WeixinCorpNotifier(properties.getId(), client, ValidatorUtils.tryValidate(wechatCorpProperties), templateManager));

    }

//    @Override
//    public ConfigMetadata getNotifierConfigMetadata() {
//        return notifierConfig;
//    }
//
//    @Override
//    public ConfigMetadata getTemplateConfigMetadata() {
//        return templateConfig;
//    }
}
